<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
<div class="container">
  <h2>Registration Car Form</h2>

  <div class="jumbotron container"> 
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-fname">First Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-lname">Last Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="country-select">Country</label>
      </div>
      <div class="col-sm-3">
        <select id="country-select" name="country" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="region-type-select">Region</label>
      </div>
      <div class="col-sm-3">
        <select id="region-type-select" name="region" class="form-control">
        </select>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="car-select">Car</label>
      </div>
      <div class="col-sm-3">
        <select id="car-select" name="car" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="car-type-select">Car type</label>
      </div>
      <div class="col-sm-3">
        <select id="car-type-select" name="car-type" disabled class="form-control">
        </select>
      </div>
    </div>
    <div class="row">
      <div class="col-sm-12" style="text-align: right;">
        <button class="btn btn-info" id="btn-send"> Send </button>
      </div>
    </div>
  </div>
</div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;
  
  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;
  
  var gObjectCarData = JSON.parse(gJsonCarData);

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function(){
    onPageLoading();
  });

  //thêm sự kiện click nút send
  $("#btn-send").click(function(){
    onBtnSendClick();
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

  //hàm xử lý sự kiện load trang 
  function onPageLoading(){
     loadDataToSelectCar();
  }

  //thêm sự kiện change cho select car
  $("#car-select").on("change", function(){
    onCarSelectChange(this); 
  })

  //hàm xử lý sự kiện change car select
  function onCarSelectChange(paramCarSelect){
    var vBrandId = $(paramCarSelect).val();
    console.log(vBrandId); 

    //load dữ liệu ra car type
    loadDataToSelectCarType(vBrandId);
  }

  //hàm xử lý sưj kiện click nút send
  function onBtnSendClick(){
    //B1: khai báo biến và thu thập dữ liệu 
    var vCarObj = {
      brandId: -1,
      brandName: "", 
      typeId: -1,
      typeName: ""
    }
    getCarObjData(vCarObj);

    //bước 2: kiểm tra dữ liệu 
     var vValid = validateCarData(vCarObj);
     if(vValid){
      //bước 3: Hiển thị dữ liệu 
        sendCarData(vCarObj);
     }
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  

  //hàm load dữ liệu vào select car
  function loadDataToSelectCar(){
    var vSelectCar = $("#car-select");

    for(var bI = 0; bI < gObjectCarData.length; bI++){
      // $("<option/>", {
      //   "value": gObjectCarData[bI].brandId,
      //   "text": gObjectCarData[bI].brandName
      // }).appendTo(vSelectCar); 

      //cách 2:
      var bOption = $("<option/>");
      bOption.prop("value", gObjectCarData[bI].brandId);
      bOption.prop("text", gObjectCarData[bI].brandName);
      vSelectCar.append(bOption); 
    }
  }
  
  //hàm load dữ liệu lên select car type 
  function loadDataToSelectCarType(paramBrandId){

    //B1: load dữ liệu brand type
    var vBrandTypes = getBrandTypeByBrandID(paramBrandId);

    //B2: reset select car type
    var vCarTypeSelect = $("#car-type-select");
    vCarTypeSelect.html("");

    //B3: set enable/disable cho select car type
    if(vBrandTypes.length == 0){
      vCarTypeSelect.prop("disabled", "disabled"); 
    }
    else
    {
      vCarTypeSelect.prop("disabled", false);
    }

    //load dữ liệu vào select data
    for(var bI = 0; bI < vBrandTypes.length; bI++){
      $("<option/>", {
        "value": vBrandTypes[bI].typeId,
        "text": vBrandTypes[bI].typeName
      }).appendTo(vCarTypeSelect);
    }

    
  }
  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
        if (gObjectCarData[vIterator].brandId === paramBrandId) {
          vBrandFound = true;
          vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
        }
        else {
          vIterator ++;
        }
    }
    return vBrandTypesResult;
  }

  //hàm thu thập  dữ liệu 
  function getCarObjData(paramCarObj){
    paramCarObj.brandId = $("#car-select").val(); 
   ///  paramCarObj.brandName = $("#car-select option:selected").val();
    paramCarObj.brandName = $("#car-select option:selected").text(); 
    paramCarObj.typeId = $("#car-type-select").val(); 
    paramCarObj.typeName = $("#car-type-select option:selected").text(); 
     
  }

  //hàm kiểm tra dữ liệu 
  function validateCarData(paramCarObj){
    if(paramCarObj.brandId == 0){
      alert("Phải chọn Car!!!");
      $("#car-select").focus();
      return false;
    }
    if(paramCarObj.typeId == -1){
      alert("Phải chọn Car type!!!");
      $("#car-type-select").focus();
      return false;
    }
    return true;
  }

  //hàm gửi dữ liệu 
  function sendCarData(paramCarObj){
    console.log(paramCarObj);
  }
</script> 

</html>